<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { CtfCard } from '~/models';
import { UseLiteYouTube, UseLocalizedVideoSubtitles } from '~/mixins';
import { SolutionsVideoModal } from '../solutions/index.vue';
export default Vue.extend({
  name: 'VideoCarouselCard',
  components: {
    SolutionsVideoModal,
  },
  mixins: [UseLiteYouTube, UseLocalizedVideoSubtitles],
  props: {
    card: {
      type: Object as PropType<CtfCard>,
      required: false,
      default: () => {},
    },
    preloadImages: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  methods: {
    handleClick(buttonData: any) {
      if (buttonData.cardLink) {
        // Make sure Vimeo analytics work:
        // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
        this.modal.open = true;
        setTimeout(() => {
          window.__vimeoRefresh();
        }, 3000);
      }
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <div class="video-carousel-card">
    <div role="button" @click="handleClick(card.fields)">
      <div class="video-carousel-card__img">
        <img
          v-if="card.fields.image?.fields?.file?.url"
          :src="card.fields?.image?.fields?.file?.url"
          alt=""
          :preload="preloadImages"
        />
      </div>
      <div class="video-carousel-card__description">
        <SlpTypography variant="body2-bold" tag="div" class="">
          {{ card.fields.description }}
        </SlpTypography>
      </div>
    </div>
    <SolutionsVideoModal
      v-show="modal.open"
      light-background
      :visible="modal.open"
      @close="closeModal"
    >
      <template #body>
        <lite-youtube
          :videoid="card.fields.cardLink"
          :title="card.fields.title"
          class="video-iframe"
        ></lite-youtube>
      </template>
    </SolutionsVideoModal>
  </div>
</template>

<style scoped lang="scss">
.video-carousel-card {
  pointer-events: all;
  cursor: pointer;
  transition: all 0.3s ease;
  background-color: #fff;
  &:hover {
    background-color: $color-surface-800;
  }
  &__img {
    object-fit: cover;
    aspect-ratio: 270 / 161;
    img {
      width: 100%;
      height: 100%;
    }
  }
  &__description {
    padding: 32px;
  }
  :deep {
    .video-iframe {
      aspect-ratio: 16 / 9;
      width: 600px;
      height: 337.5px;

      @media (max-width: $breakpoint-md) {
        width: 300px;
        height: 168.75px;
      }
    }
  }
}
</style>
